﻿// Assigns a vertical scroll bar, MovieClips used must be of exact proportionate sizes
class YSlider{
	// scroll bar track
	var track:MovieClip;
	// top cap of bar - a child of bar
	var topCap:MovieClip;
	// middle of bar - a child of bar - a 1px tall expandable MovieClip
	var middle:MovieClip;
	// top cap of bar - a child of bar
	var bottomCap:MovieClip;
	// scroll bar
	var bar:MovieClip;
	// the movable content behind the mask
	var page:MovieClip;
	// the window through which the page can be seen - align beforehand
	var mask:MovieClip;
	// move the bar and content up by their unit lengths
	var topArrow:MovieClip;
	// move the bar and content down by their unit lengths
	var bottomArrow:MovieClip;
	// the unit length of the page
	var pageUnitLength:Number;
	// the bar unit length by ratio to the page
	var barUnitLength:Number;
	// constraints
	var bar_min_y:Number;
	var bar_max_y:Number;
	var page_min_y:Number;
	var page_max_y:Number;
	var track2PageRatio:Number;
	// hack to deal with the page being shorter than the mask
	var movable:Boolean = true;
	var g:Object;
	function YSlider(page:MovieClip, mask:MovieClip, track:MovieClip, bar:MovieClip, topCap:MovieClip, middle:MovieClip, bottomCap:MovieClip, topArrow:MovieClip, bottomArrow:MovieClip, pageUnitLength:Number){
		this.page = page;
		this.mask = mask;
		this.track = track;
		this.bar = bar;
		this.topCap = topCap;
		this.middle = middle;
		this.bottomCap = bottomCap;
		this.topArrow = topArrow;
		this.bottomArrow = bottomArrow;
		this.pageUnitLength = pageUnitLength;
		bar["slider"] = this;
		bar.onPress = function(){
			this.startDrag(false, this._x, this["slider"].bar_min_y, this._x, this["slider"].bar_max_y);
		}
		track["bar"] = bar;
		track["slider"] = this;
		track.onPress = function(){
			this["bar"]._y = _ymouse - (this["bar"]._height * 0.5);
			if(this["bar"]._y > this["slider"].bar_max_y){
				this["bar"]._y = this["slider"].bar_max_y;
			}
			if(this["bar"]._y < this["slider"].bar_min_y){
				this["bar"]._y = this["slider"].bar_min_y;
			}
			this["slider"].setPage();
			this["bar"].startDrag(false, this._x, this["slider"].bar_min_y, this._x, this["slider"].bar_max_y);
		}
		bar.onMouseUp = function(){
			this.stopDrag();
		}
		bar.onMouseMove = function(){
			this["slider"].setPage();
		}
		topArrow["slider"] = this;
		topArrow.onPress = function(){
			this["slider"].stepUp();
		}
		bottomArrow["slider"] = this;
		bottomArrow.onPress = function(){
			this["slider"].stepDown();
		}
		topArrow.useHandCursor = false;
		bottomArrow.useHandCursor = false;
		bar.useHandCursor = false;
		track.useHandCursor = false;
		bar._y = track._y;
		setBarHeight();
		
	}
	function setBarHeight(){
		var mask2PageRatio = Math.min((1.0 / page._height) * mask._height, 1.0);
		var trackOperationalLength = track._height - middle._height - topCap._height - bottomCap._height;
		var middleLength = trackOperationalLength * mask2PageRatio;
		middle._yscale = (100 / middle._height) * middleLength;
		topCap._y = 0;
		middle._y = topCap._height;
		bottomCap._y = topCap._height + middle._height;
		bar_min_y = track._y;
		bar_max_y = track._y + track._height - bar._height;
		page_min_y = page._y - Math.max(page._height - mask._height, 0);
		page_max_y = page._y;
		track2PageRatio = (page._height - mask._height) / (bar_max_y - bar_min_y);
		barUnitLength = pageUnitLength / track2PageRatio;
		var currentMovable = page._height > mask._height;
		if(currentMovable != movable){
			movable = currentMovable;
			bar.enabled = movable;
			topArrow.enabled = movable;
			bottomArrow.enabled = movable;
			track.enabled = movable;
		}
	}
	function setPage(){
		var barmoved = bar._y - bar_min_y;
		var pageMoved = barmoved * track2PageRatio;
		page._y = page_max_y - pageMoved;
	}
	function stepDown(){
		bar._y = Math.min(bar._y + barUnitLength, bar_max_y);
		page._y = Math.max(page._y - pageUnitLength, page_min_y);
	}
	function stepUp(){
		bar._y = Math.max(bar._y - barUnitLength, bar_min_y);
		page._y = Math.min(page._y + pageUnitLength, page_max_y);
	}
}